--[[
Copyright (C) GtX (Andy), 2021

Author: GtX | Andy
Date: 14.04.2021
Revision: FS22-01

Contact:
https://forum.giants-software.com
https://github.com/GtX-Andy

Important:
Not to be added to any mods / maps or modified from its current release form.
No modifications may be made to this script, including conversion to other game versions without written permission from GtX | Andy
Copying or removing any part of this code for external use without written permission from GtX | Andy is prohibited.

Darf nicht zu Mods / Maps hinzugefügt oder von der aktuellen Release-Form geändert werden.
Ohne schriftliche Genehmigung von GtX | Andy dürfen keine Änderungen an diesem Skript vorgenommen werden, einschließlich der Konvertierung in andere Spielversionen
Das Kopieren oder Entfernen irgendeines Teils dieses Codes zur externen Verwendung ohne schriftliche Genehmigung von GtX | Andy ist verboten.
]]


TransferOwnershipUpdateObjectsEvent = {}

local TransferOwnershipUpdateObjectsEvent_mt = Class(TransferOwnershipUpdateObjectsEvent, Event)
InitEventClass(TransferOwnershipUpdateObjectsEvent, "TransferOwnershipUpdateObjectsEvent")

function TransferOwnershipUpdateObjectsEvent.emptyNew()
    local self = Event.new(TransferOwnershipUpdateObjectsEvent_mt)

    return self
end

function TransferOwnershipUpdateObjectsEvent.new(owningPlaceable)
    local self = TransferOwnershipUpdateObjectsEvent.emptyNew()

    self.owningPlaceable = owningPlaceable

    return self
end

function TransferOwnershipUpdateObjectsEvent:readStream(streamId, connection)
    self.owningPlaceable = NetworkUtil.readNodeObject(streamId)

    self:run(connection)
end

function TransferOwnershipUpdateObjectsEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.owningPlaceable)
end

function TransferOwnershipUpdateObjectsEvent:run(connection)
    local transferPoint = nil

    if self.owningPlaceable ~= nil and self.owningPlaceable.getTransferOwnershipPoint ~= nil then
        transferPoint = self.owningPlaceable:getTransferOwnershipPoint()
    end

    g_messageCenter:publish("TRANSFER_OWNERSHIP_UPDATE_OBJECTS", transferPoint)
end
